searchData={"items":[{"type":"module","doc":"Nebulex adapter for [Cachex][cachex].\n\n[cachex]: http://hexdocs.pm/cachex/Cachex.html","title":"Nebulex.Adapters.Cachex","ref":"Nebulex.Adapters.Cachex.html"},{"type":"module","doc":"Since Nebulex is just a wrapper on top of Cachex, the options are the same as\n[Cachex.start_link/2][cachex_start_link].\n\n[cachex_start_link]: https://hexdocs.pm/cachex/Cachex.html#start_link/2","title":"Options - Nebulex.Adapters.Cachex","ref":"Nebulex.Adapters.Cachex.html#module-options"},{"type":"module","doc":"You can define a cache using Cachex as follows:\n\n    defmodule MyApp.Cache do\n      use Nebulex.Cache,\n        otp_app: :my_app,\n        adapter: Nebulex.Adapters.Cachex\n    end\n\nWhere the configuration for the cache must be in your application\nenvironment, usually defined in your `config/config.exs`:\n\n    config :my_app, MyApp.Cache,\n      stats: true,\n      ...\n\nIf your application was generated with a supervisor (by passing `--sup`\nto `mix new`) you will have a `lib/my_app/application.ex` file containing\nthe application start callback that defines and starts your supervisor.\nYou just need to edit the `start/2` function to start the cache as a\nsupervisor on your application's supervisor:\n\n    def start(_type, _args) do\n      children = [\n        {MyApp.Cache, []},\n      ]\n\n      ...\n    end\n\nSince Cachex uses macros for some configuration options, you could also\npass the options in runtime when the cache is started, either by calling\n`MyApp.Cache.start_link/1` directly, or in your app supervision tree:\n\n    def start(_type, _args) do\n      children = [\n        {MyApp.Cache, cachex_opts()},\n      ]\n\n      ...\n    end\n\n    defp cachex_opts do\n      import Cachex.Spec\n\n      [\n        expiration: expiration(\n          # how often cleanup should occur\n          interval: :timer.seconds(30),\n\n          # default record expiration\n          default: :timer.seconds(60),\n\n          # whether to enable lazy checking\n          lazy: true\n        ),\n\n        # hooks\n        hooks: [\n          hook(module: MyHook, name: :my_hook, args: { })\n        ],\n\n        ...\n      ]\n    end\n\n> See [Cachex.start_link/2][cachex_start_link] for more information.","title":"Example - Nebulex.Adapters.Cachex","ref":"Nebulex.Adapters.Cachex.html#module-example"},{"type":"module","doc":"Using the distributed adapters with `Cachex` as a primary storage is possible.\nFor example, let's define a multi-level cache (near cache topology), where\nthe L1 is a local cache using Cachex and the L2 is a partitioned cache.\n\n    defmodule MyApp.NearCache do\n      use Nebulex.Cache,\n        otp_app: :nebulex,\n        adapter: Nebulex.Adapters.Multilevel\n\n      defmodule L1 do\n        use Nebulex.Cache,\n          otp_app: :nebulex,\n          adapter: Nebulex.Adapters.Cachex\n      end\n\n      defmodule L2 do\n        use Nebulex.Cache,\n          otp_app: :nebulex,\n          adapter: Nebulex.Adapters.Partitioned,\n          primary_storage_adapter: Nebulex.Adapters.Cachex\n      end\n    end\n\nAnd the configuration may look like:\n\n    config :my_app, MyApp.NearCache,\n      model: :inclusive,\n      levels: [\n        {MyApp.NearCache.L1, []},\n        {MyApp.NearCache.L2, primary: [transactions: true]}\n      ]\n\n> **NOTE:** You could also use [Nebulex.Adapters.Redis][nbx_redis_adapter] for\n  L2, it would be matter of changing the adapter for the L2 and the\n  configuration to set up Redis adapter.\n\n[nbx_redis_adapter]: https://github.com/elixir-nebulex/nebulex_redis_adapter\n\nSee [Nebulex examples](https://github.com/elixir-nebulex/nebulex_examples).\nYou will find examples for all different topologies, even using other adapters\nlike Redis; for all examples using the `Nebulex.Adapters.Local` adapter,\nyou can replace it by `Nebulex.Adapters.Cachex`.","title":"Distributed caching topologies - Nebulex.Adapters.Cachex","ref":"Nebulex.Adapters.Cachex.html#module-distributed-caching-topologies"},{"type":"module","doc":"Nebulex `count_all`.","title":"Nebulex.Adapters.Cachex.CustomActions.CountAll","ref":"Nebulex.Adapters.Cachex.CustomActions.CountAll.html"},{"type":"module","doc":"Nebulex `delete_all`.","title":"Nebulex.Adapters.Cachex.CustomActions.DeleteAll","ref":"Nebulex.Adapters.Cachex.CustomActions.DeleteAll.html"},{"type":"module","doc":"Custom `fetch`.","title":"Nebulex.Adapters.Cachex.CustomActions.Fetch","ref":"Nebulex.Adapters.Cachex.CustomActions.Fetch.html"},{"type":"module","doc":"Nebulex `get_all`.","title":"Nebulex.Adapters.Cachex.CustomActions.GetAll","ref":"Nebulex.Adapters.Cachex.CustomActions.GetAll.html"},{"type":"module","doc":"Custom `put_new`.","title":"Nebulex.Adapters.Cachex.CustomActions.PutNew","ref":"Nebulex.Adapters.Cachex.CustomActions.PutNew.html"},{"type":"module","doc":"Custom `put_new_all`.","title":"Nebulex.Adapters.Cachex.CustomActions.PutNewAll","ref":"Nebulex.Adapters.Cachex.CustomActions.PutNewAll.html"},{"type":"module","doc":"ETS utilities to support extra commands.\n\n> Taken from `Nebulex.Adapters.Local`.","title":"Nebulex.Adapters.Cachex.EtsUtils","ref":"Nebulex.Adapters.Cachex.EtsUtils.html"},{"type":"function","doc":"","title":"Nebulex.Adapters.Cachex.EtsUtils.ets_select_keys/8","ref":"Nebulex.Adapters.Cachex.EtsUtils.html#ets_select_keys/8"}],"content_type":"text/markdown","proglang":"elixir","producer":{"name":"ex_doc","version":"0.37.3"}}